      SUBROUTINE ACTION(IMACTIVE)
C=======================================================================
C
C     SERVICE ALL INTERACTIVE INPUT
C
C     THIS ROUTINE SETS (IMACTIVE) TO INDICATE WHETHER OR NOT
C     THERE WAS INTERACTIVE INPUT.
C
C     IMACTIVE = 0 - NO INTERACTION
C              = 1 - INTERACTION
C
C     ALL SELECTED OPTIONS ARE SERVICED INSIDE THIS ROUTINE BY
C     SETTING VARIOUS PLOT OPTIONS. UPON RETURN IF IMACTIVE = 0,
C     PROCEED TO THE NEXT PLOT. IF IMACTIVE = 1, PLOT THE SAME
C     DATA OVER AGAIN WITH THE NEW OPTIONS.
C
C=======================================================================
      INCLUDE 'implicit.h'
      CHARACTER*10 NOPT
      COMMON/OPTION/NROUND(2),IWANT(2),XRANGE(2),YRANGE(2),KWANT(2,2)
      COMMON/XYLIM/XLIM(2),XLIMR(2),YLIM(2),YLIMR(2),DXLIM,DYLIM
      COMMON/XYOFF/XOFF,YOFF,XSCALE,YSCALE,XSIZE,YSIZE
      COMMON/PLTLIM/XINCH(2),YINCH(2)
      COMMON/WAYS/IWAY(2)
      COMMON/OPS2/NOPT(40)
      COMMON/XYBOXES/XBOXER(9),YBOXER(6)
      COMMON/SHOWPT/MYSHOW
      COMMON/STARTX/XSTART(2),ISTART(2),LSTART(2),IWAYD(2),
     1 KNTERD,KNTERR
      COMMON/TERPIT/INTERD,INTERR
      COMMON/SUBPLT/YFINCH(2),YSINCH(2,3),NPLOT,MPLOT
      COMMON/XYLABI/IXLAB(2),IYLAB(2),NXLAB(2),NYLAB(2),XMULT,YMULT,
     1 XBASE,XSTEP1,XSTEP2,YBASE,YSTEP1,YSTEP2,IXSTEP,IYSTEP,IXMULT,
     2 IYMULT
      COMMON/GRIDDY/IMFINE(2)
      COMMON/LEGOFF/NOLEGS
      COMMON/MULTHT/HTMULT
C-----INITIALIZE TO MOUSE INPUT OPTION.
      IMACTIVE=1
C-----DISPLAY OPTION BOXES
    1 CALL TOPPER
C-----DELAY FOR OPTION SELECTION
      CALL PEN(2)
      CALL SHOWTEXT(54,0,'Use MOUSE to Select Option',26)
      CALL PLOTD(XBOXER(1),YBOXER(1),3)
      CALL PLOTD(XBOXER(9),YBOXER(1),2)
      CALL KIWI(KOPT,IX,IY)
C-----RETURN IF KEYBOARD INPUT.
      IF(KOPT.LE.0) GO TO 180
      CALL PEN(3)
      CALL SHOWTEXT(54,0,'                          ',26)
      CALL PLOTD(XBOXER(1),YBOXER(1),3)
      CALL PLOTD(XBOXER(9),YBOXER(1),2)
C-----HIGHLIGHT OPTION
      CALL TEXTBOX(IX,IY,NOPT(KOPT),3)
      CALL PEN(3)
      CALL SHOWTEXT(36,0,NOPT(KOPT),10)
C-----RESTORE BOX.
      CALL PEN(6)
      CALL BOXCOLORD(XBOXER(IX),YBOXER(IY),-1,3)
C=======================================================================
C
C     EXECUTE OPTION
C
C=======================================================================
C-----1 = LIN/LOG X
      IF(KOPT.NE.1) GO TO 10
      IWAY(1)=3-IWAYD(1)
      IWANT(1)=3-IWAYD(1)
      IF(IWANT(1).EQ.IABS(LSTART(1))) IWANT(1)=LSTART(1)
      INTERD=KNTERD
      INTERR=KNTERR
      RETURN
C-----2 = LIN/LOG Y
   10 IF(KOPT.NE.2) GO TO 20
C-----LIN/LOG Y
      IWAY(2)=3-IWAYD(2)
      IWANT(2)=3-IWAYD(2)
      IF(IWANT(2).EQ.IABS(LSTART(2))) IWANT(2)=LSTART(2)
      INTERD=KNTERD
      INTERR=KNTERR
      RETURN
C-----3 = ZOOM X
   20 IF(KOPT.EQ.3) GO TO 100
C-----4 = POINTS.
      IF(KOPT.NE.4) GO TO 30
      MYSHOW=1-MYSHOW
      RETURN
C-----5 = NEXT PLOT
   30 IF(KOPT.EQ.5) GO TO 180
C-----6 = SHOW ALL
      IF(KOPT.NE.6) GO TO 40
C-----DEFINE ORIGINAL RANGE
      XI1=XSTART(1)
      XI2=XSTART(2)
C-----DEFINE ORIGINAL SCALING AND INTERPOLATION.
      IWAY(1)=ISTART(1)
      IWAY(2)=ISTART(2)
      IWANT(1)=LSTART(1)
      IWANT(2)=LSTART(2)
      INTERD=KNTERD
      INTERR=KNTERR
      GO TO 170
C-----7 - RATIO
   40 IF(KOPT.NE.7) GO TO 45
      MPLOT=3-MPLOT
      RETURN
C-----10 - BLACK/WHITE
   45 IF(KOPT.NE.10) GO TO 50
      CALL NEWBACK
      RETURN
C-----11 TO 16 GRID
   50 IF(KOPT.LT.11.OR.KOPT.GT.16) GO TO 60
      IMFINE(1)=0
      IMFINE(2)=0
      II=KOPT-11
      IF(II.GT.0) IMFINE(1)=1
      IF(II.EQ.1.OR.II.EQ.3) IMFINE(1)=2
      IF(II.GT.2) IMFINE(2)=2
      IF(II.EQ.5) IMFINE(2)=1
      RETURN
C-----17 - LEGEND BOX.
   60 IF(KOPT.NE.17) GO TO 70
      NOLEGS=1-NOLEGS
      RETURN
C-----18 - BIGGER CHARACTERS
   70 IF(KOPT.NE.18) GO TO 80
      IF(HTMULT.GT.2.0) RETURN
      HTMULT=1.2*HTMULT
      IF(HTMULT.GT.2.0) HTMULT=2.0
      IMTHRU=1
      CALL SETUP(IMTHRU)
      RETURN
C-----19 - SMALLER CHARACTERS
   80 IF(KOPT.NE.19) GO TO 90
      IF(HTMULT.LT.0.5) RETURN
      HTMULT=HTMULT/1.2
      IF(HTMULT.LT.0.5) HTMULT=0.5
      IMTHRU=1
      CALL SETUP(IMTHRU)
      RETURN
C-----25 = COLOR DUMP
   90 IF(KOPT.NE.25) GO TO 95
      CALL PRINTIT
      GO TO 1
C-----36 = STOP.
   95 IF(KOPT.EQ.36) CALL ENDIT
C-----RETURN IF OPTION IS NOT DEFINED.
      RETURN
C=======================================================================
C
C     ZOOM X USING MOUSE
C
C=======================================================================
C
C     REQUEST MOUSE INPUT TO DEFINE X LIMITS.
C
  100 CALL PEN(2)
      CALL SHOWTEXT(45,0,'Use MOUSE to Define Zoomed X Limits',35)
C
C     DEFINE LOWER X LIMIT
C
  110 CALL MOUSEYD(KWAY,XIN1,YI1,1,4)
C-----RETURN IF KEYBOARD INPUT.
      IF(KWAY.EQ.4) GO TO 180
      XI1=(XIN1-XOFF)/XSCALE
      IF(XI1.LT.XINCH(1).OR.XI1.GT.XINCH(2)) GO TO 110
      CALL PEN(1)
      YIN1=YSCALE*YFINCH(1)+YOFF
      YIN2=YSCALE*YFINCH(2)+YOFF
      CALL PLOTD(XIN1,YIN1,3)
      CALL PLOTD(XIN1,YIN2,2)
C
C     DEFINE UPPER X LIMIT
C
C-----RETURN IF KEYBOARD INPUT.
  120 CALL MOUSEYD(KWAY,XIN2,YI2,1,4)
      IF(KWAY.EQ.4) GO TO 180
      XI2=(XIN2-XOFF)/XSCALE
      IF(XI2.LT.XINCH(1).OR.XI2.GT.XINCH(2)) GO TO 120
      CALL PEN(1)
      CALL PLOTD(XIN2,YIN1,3)
      CALL PLOTD(XIN2,YIN2,2)
C
C     ACCEPT ZOOMED X RANGE
C
C-----SORT INTO ASCENDING ORDER.
      IF(XI1-XI2) 140,180,130
  130 XI3=XI1
      XI1=XI2
      XI2=XI3
C-----CONVERT FROM INCHES TO DATA UNITS.
  140 DXINCH=XINCH(2)-XINCH(1)
      XI1=(XLIM(2)*(XI1-XINCH(1))+XLIM(1)*(XINCH(2)-XI1))/DXINCH
      XI2=(XLIM(2)*(XI2-XINCH(1))+XLIM(1)*(XINCH(2)-XI2))/DXINCH
      IF(IWAY(1).EQ.1) GO TO 150
      XI1=10.0**XI1
      XI2=10.0**XI2
      GO TO 160
C
C     CORRECT FOR LINEAR OFFSET MULTIPLIER
C
  150 XI1=XI1*(10.0**IXMULT)
      XI2=XI2*(10.0**IXMULT)
C
C     X RANGE SELECTED.
C
C-----ALLOW AUTOMATIC LIN/LOG SCALING FOR NEXT PLOT
  160 IWANT(1)=0
      IWANT(2)=0
      IWAY(1)=0
      IWAY(2)=0
      INTERD=KNTERD
      INTERR=KNTERR
C
C     DEFINE REQUESED X RANGE AND SET KWANT TO INDICATE REQUEST
C
  170 XRANGE(1)=XI1
      XRANGE(2)=XI2
      KWANT(1,1)=1
      KWANT(2,1)=1
      RETURN
C
C     KEYBOARD INPUT - NO INTERACTION
C
  180 IMACTIVE=0
      RETURN
      END
      SUBROUTINE SETMOUSE
C==================================================================
C
C     INITIAL SETUP FOR INTERACTION.
C
C     DEFINE LIMITS OF OPTION BOXES AND DISPLAY ALL OPTIONS.
C
C     OPTION LIMITS
C     XBOXER 1 THROUGH 9 - LEFT TO RIGHT - COLUMNS 1 THROUGH 8
C     YBOXER 1 THROUGH 6 - TOP TO BOTTOM - ROWS 1 THROUGH 5
C
C     OPTIONS 8 BY 5 = 40 OPTIONS
C
C     OPTION INDEX = IY + 5*(IX - 1)
C     IY = 1 TO 5
C     IX = 1 TO 8
C
C==================================================================
      INCLUDE 'implicit.h'
      COMMON/PLOTXY/XYPLOT(2,2),NBORD,IFLIP
      COMMON/XYBOXES/XBOXER(9),YBOXER(6)
      REAL*4 XTOPPER,YTOPPER
      COMMON/TOPXY/XTOPPER(2),YTOPPER(2)
C-----RE-SET SCREEN LIMITS TO THOSE OF THE LOCAL SCREEN.
      CALL MYSIZED(XYPLOT(1,1),XYPLOT(1,2))
C-----DEFINE X LIMITS OF OPTION BOXES
      DX=(XYPLOT(2,1)-XYPLOT(1,1))/8.0
      XBOXER(1)=XYPLOT(1,1)
      DO 10 I=2,9
   10 XBOXER(I)=XBOXER(I-1)+DX
      DY=(XYPLOT(2,2)-XYPLOT(1,2))/30.0
C-----DEFINE Y LIMITS OF OPTION BOXES
      YBOXER(1)=XYPLOT(2,2)-DY
      DO 20 I=2,6
   20 YBOXER(I)=YBOXER(I-1)-DY
C-----DEFINE AREA AT TOP TO BLANK.
      XTOPPER(1)=XYPLOT(1,1)
      XTOPPER(2)=XYPLOT(2,1)
      YTOPPER(1)=YBOXER(6)
      YTOPPER(2)=XYPLOT(2,2)
C-----RE-DEFINE TOP OF PLOTTING AREA.
      XYPLOT(2,2)=YBOXER(6)-0.01
C-----DISPLAY OPTIONS
      CALL TOPPER
C-----DISPLAY STARTING MESSAGE
c     CALL PEN(2)
c     CALL SHOWTEXT(54,0,'    Press ANY KEY to Start',26)
      RETURN
      END
      SUBROUTINE TOPPER
C==================================================================
C
C     ON FIRST CALL LOAD DEFINITION OF OPTIONS FROM 'PAGE.DAT'
C
C     DISPLAY OPTION BOXES.
C
C==================================================================
      INCLUDE 'implicit.h'
      CHARACTER*10 NOPT,NOPT1
      COMMON/OPS2/NOPT(40)
      COMMON/XYBOXES/XBOXER(9),YBOXER(6)
      REAL*4 XTOPPER,YTOPPER
      COMMON/TOPXY/XTOPPER(2),YTOPPER(2)
C
C     ON FIRST CALL READ OPTIONS
C
      DATA IPASS/0/
      IF(IPASS.NE.0) GO TO 40
      IPASS=1
C-----READ OPTIONS
      OPEN(30,FILE='PAGE.DAT')
      DO 10 I=1,40
   10 NOPT(I)=' '
   20 READ(30,80,END=30,ERR=30) IOPT,NOPT1
      IF(IOPT.LT.1.OR.IOPT.GT.40) GO TO 20
      NOPT(IOPT)=NOPT1
      GO TO 20
   30 CLOSE(30)
C
C     DISPLAY OPTIONS.
C
C-----BLANK THE TOP OF THE SCREEN
   40 CALL BOXCOLOR(XTOPPER,YTOPPER,0,0)
      CALL PEN(2)
      CALL SHOWTEXT(1,0,'PLOTTAB (Version 2013-1)',24)
      CALL SHOWTEXT(54,0,'Use MOUSE to Select Option',26)
      CALL PLOTD(XBOXER(1),YBOXER(1),3)
      CALL PLOTD(XBOXER(9),YBOXER(1),2)
C-----DISPLAY OPTIONS
      CALL PEN(2)
      KOPT=0
      DO 60 IX=1,8
      DO 50 IY=1,5
      KOPT=KOPT+1
      CALL TEXTBOX(IX,IY,NOPT(KOPT),4)
   50 CONTINUE
   60 CONTINUE
C-----RESTORE OPTION BOXES
      CALL PEN(6)
      DO 70 IX=1,8
      DO 70 IY=1,5
   70 CALL BOXCOLORD(XBOXER(IX),YBOXER(IY),-1,3)
      CALL PEN(2)
      CALL PLOTD(XBOXER(1),YBOXER(1),3)
      CALL PLOTD(XBOXER(9),YBOXER(1),2)
      RETURN
   80 FORMAT(I3,1X,A10,A10,A60)
      END
      SUBROUTINE KIWI(KOPT,IX,IY)
C==================================================================
C
C     SELECT INPUT OPTION
C
C     KOPT  = 0 = KEYBOARD INPUT
C           = 1 THROUGH 40 = OPTION BOX
C     IX    = OPTION COLUMN - 1 THROUGH 8
C     IY    = OPTION ROW    - 1 THROUGH 5
C
C==================================================================
      INCLUDE 'implicit.h'
      COMMON/XYBOXES/XBOXER(9),YBOXER(6)
C-----DELAY FOR MOUSE OR KEYBOARD INPUT.
   10 CALL MOUSEYD(KWAY,XM,YM,1,4)
C-----RETURN ON KEYBOARD INPUT
      IF(KWAY.NE.4) GO TO 20
      IX=0
      IY=0
      KOPT=0
      RETURN
C-----SEE IF MOUSE X,Y IS INSIDE ON OPTION BOX.
   20 DO 30 IX=1,8
      IF(XM.LT.XBOXER(IX)) GO TO 10
      IF(XM.LE.XBOXER(IX+1)) GO TO 40
   30 CONTINUE
C-----NO - KEEP READING MOUSE.
      GO TO 10
   40 DO 50 IY=1,5
      IF(YM.GT.YBOXER(IY)) GO TO 10
      IF(YM.GE.YBOXER(IY+1)) GO TO 60
   50 CONTINUE
C-----NO - KEEP READING MOUSE.
      GO TO 10
C-----YES
   60 KOPT=IY+5*(IX-1)
      RETURN
      END
      FUNCTION LENGTH(CHAR,NCHAR)
C=====================================================================
C
C     DEFINE THE NON-BLANK LENGTH OF A CHARACTER STRING
C
C=====================================================================
      INCLUDE 'implicit.h'
      CHARACTER*1 CHAR,BLANK
      DIMENSION CHAR(NCHAR)
      DATA BLANK/' '/
      DO 10 I=NCHAR,1,-1
      IF(CHAR(I).NE.BLANK) GO TO 20
   10 CONTINUE
      I=0
   20 LENGTH=I
      RETURN
      END
      SUBROUTINE TEXTBOX(IX,IY,OPT10,MYCOLOR)
C=====================================================================
C
C     DISPLAY OPTION
C
C     IX      = 1 THROUGH 8 = COLUMN
C     IY      = 1 THROUGH 5 = ROW
C     OPT10   = 10 CHARACTER OPTION
C     MYCOLOR = COLOR DISPLAYED
C
C=====================================================================
      INCLUDE 'implicit.h'
      CHARACTER*10 OPT10
      LONG=LENGTH(OPT10,10)
      IF(LONG.LE.0) RETURN
      CALL PEN(MYCOLOR)
C-----DISPLAY OPTION IN OPTION BOX
      CALL SHOWTEXT(10*(IX-1)+1,IY,OPT10,10)
      RETURN
      END
C=======================================================================
C
C     REAL*8 TO REAL*4 INTERFACE
C
C=======================================================================
      SUBROUTINE PLOTD(XD,YD,IWAY)
      REAL*8 XD,YD
      REAL*4 X ,Y
      X = XD
      Y = YD
      CALL PLOT(X,Y,IWAY)
      RETURN
      END
      SUBROUTINE MYSIZED(XD,YD)
      REAL*8 XD(2),YD(2)
      REAL*4 X (2),Y (2)
      CALL MYSIZE(X(1),Y(1))
      XD(1) = X(1)
      XD(2) = X(2)
      YD(1) = Y(1)
      YD(2) = Y(2)
      RETURN
      END
      SUBROUTINE MOUSEYD(KWAY,XD,YD,IWAY1,IWAY2)
      REAL*8 XD,YD
      REAL*4 X ,Y
      CALL MOUSEY(KWAY,X,Y,IWAY1,IWAY2)
      XD = X
      YD = Y
      RETURN
      END
      SUBROUTINE BOXCOLORD(XD,YD,IWAY1,IWAY2)
      REAL*8 XD(2),YD(2)
      REAL*4 X (2),Y (2)
      X(1) = XD(1)
      X(2) = XD(2)
      Y(1) = YD(1)
      Y(2) = YD(2)
      CALL BOXCOLOR(X(1),Y(1),IWAY1,IWAY2)
      RETURN
      END
